' ********************************************************
' *** ***
' *** Ewiger Blinker ***
' *** ***
' ********************************************************

$regfile = "ATtiny13.DAT"
$crystal = 16000                                            'Frequenz des internen Oszillators
$hwstack = 2                                                'hardwarestack herabsetzen damit gengend variablen zur verfgung stehen

Config Adc = Single , Prescaler = Auto
Config Portb = &B00001000                                   'Pinb.3 auf 'Ausgang', Rest auf 'Eingang' schalten
Portb = 0                                                   'Ausgnge auf Low setzen
Stop Ac                                                     'Analog-Komparator abschalten, um Strom zu sparen

Wdtcr = &B11010011                                          'Watchdog definieren: 0.125 Sekunden, Interrupt auslsen, kein Reset
Enable Interrupts                                           'Interrupts freigeben

Const Tagschwelle = 800                                     'Schwellwert fr Schlafmodus
Dim Ldr As Integer                                          '0 = Dunkel, 1023 = Hell

Do
 Gosub Pause
 Start Adc                                                  'A/D-Wandler starten
 Ldr = Getadc(2)                                            'Helligkeitswert einlesen
 Stop Adc                                                   'A/D-Wandler zum Stromsparen wieder stoppen
 If Ldr <= Tagschwelle Then
  Gosub Blinken                                             'Bei groer nderung Dunkel->Hell: Blinken
 End If
Loop

Blinken:                                                    'LED blinken lassen
  Portb.3 = 1
  Reset Watchdog
  Powerdown
  Portb.3 = 0
Return

Pause:
 Wdtcr = &B11110001                                         'Watchdog auf 8 Sekunden stellen
 Reset Watchdog
 Powerdown
 Wdtcr = &B11010011                                         'Watchdog wieder auf 0,125 Sekunden zurckstellen
Return

End